import * as Agenda from 'agenda';
import { Container } from 'inversify';
export interface AgendaTaskConfig {
    key: string;
    target: any;
    options?: Agenda.JobOptions;
    focus?: boolean;
}
export interface AgendaTaskInterval<T> {
    interval: number | string;
    data: T;
}
export interface AgendaTaskCommand {
    execute(job: Agenda.Job<Agenda.JobAttributesData>): Promise<void>;
}
export declare class InversifyAgendaTasksConfiguration {
    tasks: AgendaTaskConfig[];
    intervals: {
        [key: string]: {
            key: string;
            data?: any;
        }[];
    };
    decorateAndRegister(target: any, key: string, options: Agenda.JobOptions, intervals: (number | string | AgendaTaskInterval<any>)[], focus: boolean): void;
}
export declare const inversifyAgendaTasksConfiguration: InversifyAgendaTasksConfiguration;
export declare function task(key: string, int?: (number | string | AgendaTaskInterval<any>) | (number | string | AgendaTaskInterval<any>)[], options?: Agenda.JobOptions, focus?: boolean): (target: any) => void;
export declare function ftask(key: string, int?: (number | string | AgendaTaskInterval<any>) | (number | string | AgendaTaskInterval<any>)[], options?: Agenda.JobOptions): (target: any) => void;
export declare function xtask(key: string, int?: (number | string | AgendaTaskInterval<any>) | (number | string | AgendaTaskInterval<any>)[], options?: Agenda.JobOptions): void;
export declare class InversifyAgenda {
    private container;
    private config;
    errorHandlers: ((err: Error) => void)[];
    constructor(container: Container, config: {
        agenda?: Agenda;
        db?: {
            address: string;
            collection?: string;
            options?: any;
        };
    });
    onError(hanlder: (err: Error) => void): this;
    build(): Agenda;
    defineTaskService(container: Container, agenda: Agenda, key: string, target: symbol, options: Agenda.JobOptions): void;
}
export declare class InversifyAgendaService {
    private agenda;
    constructor(agenda: Agenda);
    now<T extends Agenda.JobAttributesData = Agenda.JobAttributesData>(task: any, data?: T): Promise<Agenda.Job<T>>;
}
